      PROGRAM EXAMPL
      CHARACTER*58 CR0,CR1(15),CR2(8),CDEV*4,C*1

C     Commonblock for data (only used for the example program to save
C     space)
      COMMON /WDATA/ XRAY(100),Y1RAY(100),Y2RAY(100),ZMAT(50,50)

      DATA CR0/
     *'**********************************************************'/

      DATA CR1/
     *'                      DISLIN Examples                     ',
     *'                                                          ',
     *'Fortran Demo Program of the Data Plotting Library DISLIN. ',
     *'Author: H. Michels,  Max-Planck-Institut fuer Aeronomie,  ',
     *'                D-37189 Katlenburg-Lindau, Postfach 20    ',
     *'                                                          ',
     *'Device:      defines the file format or the graphics card.',
     *'   = CONS    VGA ( 640 * 480 *  16, Standard, mode:  18)  ',
     *'             Additional modes can be defined with DISVID. ',
     *'   = GKSL    A GKSLIN metafile will be created.           ',
     *'   = CGM     A CGM metafile will be created.              ',
     *'   = HPGL    A HPGL file will be created.                 ',
     *'   = POST    A PostScript file will be created.           ',
     *'   = PSCL    A coloured PostScript file will be created.  ',
     *'   = KYOC    A Prescribe file will be created.            '/

      DATA CR2/
     *'                    DISLIN Examples (II)                  ',
     *'                                                          ',
     *' 0: Program end                  6: Pie Charts            ',
     *' 1: World Coastlines             7: Instruction Alph.     ',
     *' 2: Elliptical Proj.             8: 3-D Colour Plot       ',
     *' 3: Azimuthal Proj.              9: Shaded World          ',
     *' 4: Contours                    10: Colour Tables         ',
     *' 5: Bar Graphs                  30: Menue end             '/

10    WRITE(6,'(/4X,3A)')            '/****',CR0,   '****/'
      WRITE(6,'(4X,3A,14(/4X,3A))') ('/**  ',CR1(I),'  **/',I=1,15)
      WRITE(6,'(4X,3A)')             '/****',CR0,   '****/'

      WRITE(6,'(/4X,A)') '_Device: '
      READ(5,'(A)') CDEV
      IF(CDEV.EQ.' ') GOTO 100

      CALL UPSTR(CDEV)
      CALL METAFL(CDEV)

20    WRITE(6,'(/4X,3A)')            '/****',CR0,   '****/'
      WRITE(6,'(4X,3A,7(/4X,3A))') ('/**  ',CR2(I),'  **/',I=1,8)
      WRITE(6,'(4X,3A)')             '/****',CR0,   '****/'

      WRITE(6,'(/4X,A)') '_Option: '
      READ(5,*) IOPT

      CALL SETPAG('DA4L')
      IF(IOPT.EQ.1) THEN
        CALL EXA13_1
      ELSE IF(IOPT.EQ.2) THEN
        CALL EXA13_2
      ELSE IF(IOPT.EQ.3) THEN
        CALL EXA13_3
      ELSE IF(IOPT.EQ.4) THEN
        CALL EXA14_1
      ELSE IF(IOPT.EQ.5) THEN
        CALL EXA10_1
      ELSE IF(IOPT.EQ.6) THEN
        CALL EXA10_2
      ELSE IF(IOPT.EQ.7) THEN
        CALL EXA6_1
      ELSE IF(IOPT.EQ.8) THEN
        CALL EXA11_1
      ELSE IF(IOPT.EQ.9) THEN
        CALL EXA13
      ELSE IF(IOPT.EQ.10) THEN
        CALL EXA14
      ELSE IF(IOPT.EQ.30) THEN
	GOTO 10
      ELSE IF(IOPT.EQ.0) THEN
	GOTO 100
      END IF

      WRITE(6,'(4X,A)') 'Press RETURN to continue ...'
      READ(5,'(A)') C
      IF(C.NE.' ') C=' '
      GOTO 20

100   CONTINUE
      END

      SUBROUTINE EXA13_1
      CALL SETPAG('DA4L')
      CALL DISINI
      CALL PAGERA
      CALL COMPLX

      CALL FRAME(3)
      CALL AXSPOS(400,1850)
      CALL AXSLEN(2400,1400)

      CALL NAME('Longitude','X')
      CALL NAME('Latitude','Y')
      CALL TITLIN('World Coastlines and Lakes',3)

      CALL LABELS('MAP','XY')
      CALL GRAFMP(-180.,180.,-180.,90.,-90.,90.,-90.,30.)

      CALL GRIDMP(1,1)
      CALL COLOR('GREEN')
      CALL WORLD
      CALL COLOR('WHITE')

      CALL HEIGHT(50)
      CALL TITLE
      CALL DISFIN
      END

      SUBROUTINE EXA13_2
      CHARACTER*6 CPROJ(3),CTIT*60
      DATA CPROJ/'Sanson','Winkel','Hammer'/

      CALL SETPAG('DA4P')
      CALL DISINI
      CALL PAGERA
      CALL COMPLX

      CALL HEIGHT(40)
      CALL AXSLEN(1600,750)

      NYA=3850
      DO I=1,3
        NYA=NYA-950
        CALL AXSPOS(250,NYA)

        CALL PROJCT(CPROJ(I))
        CALL NOCLIP
        CALL GRAFMP(-180.,180.,-180.,30.,-90.,90.,-90.,15.)

        WRITE(CTIT,'(2A)') 'Elliptical Projection of ',CPROJ(I)
        CALL TITLIN(CTIT,4)
        CALL TITLE

	CALL COLOR('GREEN')
	CALL WORLD
	CALL COLOR('WHITE')

        CALL GRIDMP(1,1)
        CALL ENDGRF
      END DO

      CALL DISFIN
      END

      SUBROUTINE EXA13_3
      DIMENSION NXA(4),NYA(4),XPOL(4),YPOL(4)
      CHARACTER*60 CTIT
      DATA NXA/200,1150,200,1150/NYA/1600,1600,2700,2700/
      DATA XPOL/0.,0.,0.,0./YPOL/0.,45.,90.,-45./

      CTIT='Azimuthal Lambert Projections'

      CALL SETPAG('DA4P')
      CALL DISINI
      CALL PAGERA
      CALL COMPLX

      CALL HEIGHT(50)
      NL=NLMESS(CTIT)
      NX=(2250-NL)/2.
      CALL MESSAG(CTIT,NX,300)

      CALL AXSLEN(900,900)
      CALL PROJCT('LAMBERT')

      DO I=1,4
        CALL AXSPOS(NXA(I),NYA(I))
        CALL MAPPOL(XPOL(I),YPOL(I))
        CALL GRAFMP(-180.,180.,-180.,30.,-90.,90.,-90.,30.)

        CALL COLOR('GREEN')
	CALL WORLD
	CALL COLOR('WHITE')
        CALL GRIDMP(1,1)
        CALL ENDGRF
      END DO

      CALL DISFIN
      END

      SUBROUTINE EXA14_1
      PARAMETER (N=50)
      COMMON /WDATA/ XRAY(100),YRAY(100),Y2RAY(100),ZMAT(50,50)

      FPI=3.14159/180.
      STEP=360./(N-1)

      DO I=1,N
        XRAY(I)=(I-1.)*STEP
	YRAY(I)=(I-1.)*STEP
      END DO

      DO I=1,N
        DO J=1,N
	  ZMAT(I,J)=2*SIN(XRAY(I)*FPI)*SIN(YRAY(J)*FPI)
        END DO
      END DO

      CALL SETPAG('DA4P')
      CALL DISINI
      CALL PAGERA
      CALL COMPLX

      CALL TITLIN('Contour Plot',1)
      CALL TITLIN('F(X,Y) = 2 * SIN(X) * SIN(Y)',3)

      CALL NAME('X-axis','X')
      CALL NAME('Y-axis','Y')

      CALL INTAX
      CALL AXSPOS(450,2670)
      CALL GRAF(0.,360.,0.,90.,0.,360.,0.,90.)

      CALL HEIGHT(30)
      DO I=1,9
        CALL SETCLR(I*25)
        ZLEV=-2.+(I-1)*0.5
        IF(I.EQ.5) THEN
          CALL LABELS('NONE','CONTUR')
        ELSE
          CALL LABELS('FLOAT','CONTUR')
        END IF
	CALL CONTUR(XRAY,N,YRAY,N,ZMAT,ZLEV)
      END DO

      CALL HEIGHT(50)
      CALL COLOR('WHITE')
      CALL TITLE

      CALL DISFIN
      END

      SUBROUTINE EXA6_1
      CHARACTER*100 CT0,CT1,CT2,CT3,CTIT

      CTIT='Instruction Alphabet'
      CT1='{M2}C{M4}(x) ='//
     *    ' {M3P}v{M4}e{E}-t{R}t{E}x-1{R}dt{GDH0.4F-1}0{U1.4M3F3}l'

      CT2='lim{GDHC}x{M3CD1.1}a{C}l{RM}'//
     *    '  (1 + {PUH} 1 {RVGD0.5H} x {R}){U1.2H}x{R} = e'

      CT0='Character{H0.5} height{RZ-30}  incli{Z30}nation {ZW0.5} '//
     *    ' ratio {WK} fixed width'

      CT3='Underscoring{L}    {P}twice{J}    vectors {PA8V}'
      NY=1100

      CALL SETPAG('DA4L')
      CALL DISINI
      CALL PAGERA
      CALL COMPLX
      CALL COLOR('CYAN')

      CALL HEIGHT(50)
      NL=NLMESS(CTIT)
      CALL MESSAG(CTIT,(2970-NL)/2,250)

      CALL HEIGHT(36)
      CALL MESSAG('1.)',300,450)
      CALL MESSAG(CT0,500,450)

      CALL HEIGHT(50)
      CALL SMXALF('INST','{','}',1)
      CALL MESSAG(CT0,500,550)

      CALL RESET('SMXA')
      CALL HEIGHT(36)
      CALL MESSAG('2.)',300,750)
      CALL MESSAG(CT3,500,750)

      CALL HEIGHT(50)
      CALL SMXALF('INST','{','}',1)
      CALL MESSAG(CT3,500,850)

      CALL RESET('SMXALF')
      CALL HEIGHT(36)
      CALL MESSAG('3.)',300,NY)
      CALL MESSAG(CT1,500,NY)

      CALL SMXALF('INST','{','}',1)
      CALL HEIGHT(80)
      CALL MESSAG(CT1,900,NY+150)

      CALL HEIGHT(36)
      CALL RESET('SMXA')
      CALL MESSAG('4.)',300,NY+450)
      CALL MESSAG(CT2,500,NY+450)

      CALL HEIGHT(80)
      CALL SMXALF('INST','{','}',1)
      CALL MESSAG(CT2,900,NY+600)
      CALL DISFIN
      END

      SUBROUTINE EXA10_1
      DIMENSION X(9),Y(9),Y1(9),Y2(9),Y3(9)
      CHARACTER*60 CTIT,CBUF*24

      DATA  X/1.,2.,3.,4.,5.,6.,7.,8.,9./ Y/9*0./
     *     Y1/1.,1.5,2.5,1.3,2.0,1.2,0.7,1.4,1.1/
     *     Y2/2.,2.7,3.5,2.1,3.2,1.9,2.0,2.3,1.8/
     *     Y3/4.,3.5,4.5,3.7,4.,2.9,3.0,3.2,2.6/

      NYA=2700
      CTIT='Bar Graphs (BARS)'

      CALL SETPAG('DA4P')
      CALL DISINI
      CALL PAGERA
      CALL COMPLX
      CALL TICKS(1,'X')
      CALL INTAX
      CALL AXSLEN(1600,700)
      CALL TITLIN(CTIT,3)

      CALL LEGINI(CBUF,3,8)
      CALL LEGLIN(CBUF,'FIRST',1)
      CALL LEGLIN(CBUF,'SECOND',2)
      CALL LEGLIN(CBUF,'THIRD',3)
      CALL LEGTIT(' ')
      CALL GRACE(-5)
      CALL SHDPAT(5)
      DO I=1,3
        IF(I.GT.1) CALL LABELS('NONE','X')
        CALL AXSPOS(300,NYA-(I-1)*800)

        CALL GRAF(0.,10.,0.,1.,0.,5.,0.,1.)

        IF(I.EQ.1) THEN
	  CALL BARGRP(3,0.15)
	  CALL COLOR('RED')
	  CALL BARS(X,Y,Y1,9)
	  CALL COLOR('GREEN')
	  CALL BARS(X,Y,Y2,9)
	  CALL COLOR('BLUE')
	  CALL BARS(X,Y,Y3,9)
	  CALL COLOR('WHITE')
          CALL RESET('BARGRP')
        ELSE IF(I.EQ.2) THEN
          CALL HEIGHT(30)
          CALL LABELS('DELTA','BARS')
          CALL LABPOS('CENTER','BARS')
	  CALL COLOR('RED')
	  CALL BARS(X,Y,Y1,9)
	  CALL COLOR('GREEN')
	  CALL BARS(X,Y1,Y2,9)
	  CALL COLOR('BLUE')
	  CALL BARS(X,Y2,Y3,9)
          CALL COLOR('WHITE')
          CALL HEIGHT(36)
        ELSE IF(I.EQ.3) THEN
          CALL LABELS('SECOND','BARS')
          CALL LABPOS('OUTSIDE','BARS')
	  CALL COLOR('RED')
	  CALL BARS(X,Y,Y1,9)
	  CALL COLOR('WHITE')
        END IF

        IF(I.NE.3) CALL LEGEND(CBUF,7)

        IF(I.EQ.3) THEN
          CALL HEIGHT(50)
          CALL TITLE
        END IF

        CALL ENDGRF
      END DO

      CALL DISFIN
      END

      SUBROUTINE EXA10_2
      DIMENSION XRAY(5)
      CHARACTER*60 CTIT,CBUF*40
      DATA XRAY/1.,2.5,2.,2.7,1.8/

      CTIT='Pie Charts (PIEGRF)'
      NYA=2800

      CALL SETPAG('DA4P')
      CALL DISINI
      CALL PAGERA
      CALL COMPLX
      CALL AXSLEN(1600,1000)
      CALL TITLIN(CTIT,2)
      CALL CHNPIE('BOTH')

      CALL LEGINI(CBUF,5,8)
      CALL LEGLIN(CBUF,'FIRST',1)
      CALL LEGLIN(CBUF,'SECOND',2)
      CALL LEGLIN(CBUF,'THIRD',3)
      CALL LEGLIN(CBUF,'FOURTH',4)
      CALL LEGLIN(CBUF,'FIFTH',5)

C     INDIVIDUELLE SCHRAFFUREN AUSWAEHLEN
      CALL PATCYC(1,7)
      CALL PATCYC(2,4)
      CALL PATCYC(3,13)
      CALL PATCYC(4,3)
      CALL PATCYC(5,5)

      DO I=1,2
        CALL AXSPOS(250,NYA-(I-1)*1200)
        IF(I.EQ.2) THEN
          CALL LABPOS('EXTERNAL','PIE')
          CALL LABELS('DATA','PIE')
        END IF

        CALL PIEGRF(CBUF,1,XRAY,5)

        IF(I.EQ.2) THEN
          CALL HEIGHT(50)
          CALL TITLE
        END IF
        CALL ENDGRF
      END DO
      CALL DISFIN
      END

      SUBROUTINE EXA11_1
      PARAMETER (N=50)
      COMMON /WDATA/ XRAY(100),Y1RAY(100),Y2RAY(100),ZMAT(50,50)

      FPI=3.1415927/180.
      STEP=360./(N-1)
      DO I=1,N
        X=(I-1.)*STEP
        DO J=1,N
          Y=(J-1.)*STEP
          ZMAT(I,J)=2*SIN(X*FPI)*SIN(Y*FPI)
        END DO
      END DO

      CALL DISINI
      CALL PAGERA
      CALL COMPLX

      CALL TITLIN('3-D Colour Plot of the Function',1)
      CALL TITLIN('F(X,Y) = 2 * SIN(X) * SIN(Y)',3)

      CALL NAME('X-axis','X')
      CALL NAME('Y-axis','Y')
      CALL NAME('Z-axis','Z')

      CALL GRACE(-3)
      CALL INTAX
      CALL AUTRES(N,N)
      CALL AXSPOS(300,1850)
      CALL AX3LEN(2200,1400,1400)

      CALL GRAF3(0.,360.,0.,90.,0.,360.,0.,90.,-2.,2.,-2.,1.)
      CALL CRVMAT(ZMAT,N,N,1,1)

      CALL HEIGHT(50)
      CALL TITLE
      CALL MPAEPL(3)
      CALL DISFIN
      END

      SUBROUTINE EXA13
      CHARACTER*4 COPT(7),CLR(7)
      DATA COPT/'ANTA','AUST','EURA','AFRI','NORT','SOUT','LAKE'/
     *    ,CLR /'WHIT','MAGE','GREE','RED' ,'CYAN','YELL','BLUE'/

      CALL DISINI
      CALL SETVLT('SMALL')
      CALL PAGERA
      CALL COMPLX

      CALL AXSPOS(350,1850)
      CALL AXSLEN(2270,1450)

      CALL NAME('Longitude','X')
      CALL NAME('Latitude','Y')
      CALL TITLIN('Shaded World',3)
      CALL PROJCT('HAMMER')
      CALL NOCLIP
      CALL GRAFMP(-180.,180.,-180.,60.,-90.,90.,-90.,30.)

      CALL HTITLE(45)
      CALL TITLE

      CALL SHDPAT(16)

      CALL GRIDMP(1,1)
      DO I=1,7
        CALL COLOR(CLR(I))
        CALL SHDMAP(COPT(I))
      END DO

      CALL DISFIN
      END

      SUBROUTINE EXA14
      CHARACTER*4 CVLT
      DATA NB,NH,NCOL/100,80,0/

      WRITE(6,'(A)')
     *  ' Give the colour table (SMALL, RAIN, SPEC, GREY, VGA): '
      READ(5,'(A)') CVLT

      CALL DISINI
      CALL SETVLT(CVLT)
      CALL PAGERA

      CALL HEIGHT(30)
      NCOL=0
      DO I=1,13
        NY=100+(I-1)*155
        DO J=1,20
          NX=100+(J-1)*145
          IF(NCOL.LE.255) THEN
            CALL POINT(NX,NY,NB,NH,NCOL)
            XCOL=NCOL
            NL=NLNUMB(XCOL,-1)
            CALL SETCLR(255)
            CALL NUMBER(XCOL,-1,NX-NL/2,NY+60)
            NCOL=NCOL+1
          END IF
        END DO
      END DO
      CALL DISFIN
      END
